*:*****************************************************************************
*:
*:        Program: D:\FOXPRO2\BOXPUSH.PRG
*:
*:         System: Box Push Buttons
*:         Author: Charles Alan Butler
*:      Copyright (c) 1992,1993, MIS Consulting
*:  Last modified: 12/31/92     11:41
*:
*:      Called by: DEMOBOX.PRG                       
*:
*:      Documented 12/31/92 at 11:44               FoxDoc  version 2.10e
*:*****************************************************************************
*Function BoxPush(), will put a box around push buttons

PARAMETERS bbRow,bCol,bOrient,bText,bColor,bSize,bSingle
* Parameters
* 1 Row of the first button (numeric)
* 2 Col of the first button (numeric)
* 3 H=horizontal else vertical   '<not H>'=vertical
* 4 Text of buttons 'Ok;Cancel'  strip out special characters
* 5 Color	'W/B'
* 5 Size statement   'n,1,3'   (<ignore>,<Width>,<Spaces>)
* 6 Single boxes if .T. else group box

PRIVATE NoOfBut,bSpace,BoxRowT,BoxColL,ButText,bMaxWid,bWidTotal
PRIVATE bLines,bWidth,bFixWid,BoxString,DoubleLine

IF EMPTY(bText)
   RETURN .T.
ENDIF

NoOfBut = OCCURS(';',bText)+1   &&  This is the number of buttons
bOrient = UPPER(bOrient)
BoxRowT = bbRow-1
BoxColL = bCol-1


IF EMPTY(bSize) && Use Default
   bFixWid = 0
   bSpace = 1
ELSE
   bFixWid = VAL(SUBSTR(bSize,AT(',',bSize)+1))
   bSpace = IIF(OCCURS(',',bSize)<2,1,VAL(SUBSTR(bSize,RAT(',',bSize)+1)))
ENDIF

* - - - - - - - - - establish button widths - - - - - - - - - - - - - *
DIMENSION bWidth(NoOfBut)
bWidTotal=0   &&  total width in horizontal buttons
bMaxWid = 0   &&  width of the widest button
FOR i = 1 TO NoOfBut
   IF i < NoOfBut
      ButText=LEFT(bText,AT(';',bText)-1)
      bText=SUBSTR(bText,AT(';',bText)+1)
   ELSE
      ButText=bText
   ENDIF
   bWidth(i)=MAX(bFixWid,LEN(ButText)+2)
   bWidTotal = bWidTotal + bWidth(i)
   IF bOrient!='H'
      bMaxWid = IIF(bMaxWid>bWidth(i),bMaxWid,bWidth(i))
   ELSE
      bMaxWid = bMaxWid + bWidth(i)  &&  Width of Horizontal buttons
   ENDIF
ENDFOR

* - - - - - - - - - - - - - Build Box Array - - - - - - - - - - - - - *
IF .NOT. bSingle
   bLines = IIF(bOrient!='H',NoOfBut+bSpace*(NoOfBut)+1,3)
   PRIVATE bBoxText
   DIMENSION bBoxText(bLines)
   bBoxText = ''
ENDIF

DoubleLine=REPL(CHR(205),bMaxWid)
BoxString = ['','','','','','','','']

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
* - - - - - - - - - - - - - Display Box - - - - - - - - - - - - - - - *
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
DO CASE
   *...............Vertical group box w/ no partitions...................*
CASE bOrient!='H' .AND. bSpace=0
   @ BoxRowT,BoxColL TO ;
      BoxRowT+2*NoOfBut+(NoOfBut-1)*(bSpace-1),BoxColL+1+bMaxWid  ;
      &BoxString COLOR &bColor
   RETURN .T.
   
   *..............Vertical single box per  Button........................*
CASE bOrient!='H' .AND. bSingle
   FOR i = 1 TO NoOfBut
      @ BoxRowT+(i-1)*2+(i-1)*(bSpace-1),BoxColL TO ;
         BoxRowT+2*i+(i-1)*(bSpace-1),BoxColL+1+bMaxWid  ;
         &BoxString COLOR &bColor
   ENDFOR
   RETURN .T.
   
   *.................Vertical Buttons in a group box.....................*
CASE bOrient!='H'
   FOR i = 1 TO bLines
      DO CASE
      CASE i = 1   &&  Box Top	   'ͻ'
         bBoxText(i) = CHR(201)+LEFT(DoubleLine,bMaxWid)+CHR(187)
      CASE i = bLines   &&  Box Bottom	 'ͼ'
         bBoxText(i) = CHR(200)+LEFT(DoubleLine,bMaxWid)+CHR(188)
      CASE INT((i-1)/(bSpace+1))=(i-1)/(bSpace+1) && Box Separator '͹'
         bBoxText(i) = CHR(204)+LEFT(DoubleLine,bMaxWid)+CHR(185)
      OTHERWISE	&& inside of box   '        '
         bBoxText(i) =CHR(186)+SPACE(bMaxWid)+CHR(186)
      ENDCASE
   ENDFOR
   
   *...............Horizontal group box w/ no partitions................*
CASE bSpace=0
   @ BoxRowT,BoxColL TO ;
      BoxRowT+2,BoxColL+bWidTotal+1 ;
      &BoxString COLOR &bColor
   
   *.................Horizontal single box per buttons..................*
CASE bSingle
   *	bWidTotal=bWidth(NoOfBut)
   **  display backwards in case of overlap (bSpace=1)
   FOR i = NoOfBut TO 1 STEP -1
      @ BoxRowT,BoxColL+(i-1)*(bSpace)+bWidTotal-bWidth(i) TO ;
         BoxRowT+2,BoxColL+(i-1)*(bSpace)+bWidTotal+1 ;
         &BoxString COLOR &bColor
      bWidTotal = bWidTotal - bWidth(i)
   ENDFOR
   RETURN .T.
   
   bWidTotal=0
   FOR i = 1 TO NoOfBut
      @ BoxRowT,BoxColL+(i-1)*(bSpace)+bWidTotal TO ;
         BoxRowT+2,BoxColL+(i-1)*(bSpace)+bWidTotal+bWidth(i)+1 ;
         &BoxString COLOR &bColor
      bWidTotal = bWidTotal + bWidth(i)
   ENDFOR
   RETURN .T.
   
   *.................Horizontal buttons in a group box..................*
OTHERWISE
   FOR i = 1 TO NoOfBut   &&  build text area plus separator ''
      bBoxText(1) = bBoxText(1)+LEFT(DoubleLine,bWidth(i)+(bSpace-1))+CHR(203)
      bBoxText(2) = bBoxText(2)+SPACE(bWidth(i)+(bSpace-1))+CHR(186)
      bBoxText(3) = bBoxText(3)+LEFT(DoubleLine,bWidth(i)+(bSpace-1))+CHR(202)
   ENDFOR
   **  Add corners and remove last separator
   bBoxText(1) = CHR(201)+LEFT(bBoxText(1),LEN(bBoxText(1))-1)+CHR(187)
   bBoxText(2) = CHR(186)+LEFT(bBoxText(2),LEN(bBoxText(2))-1)+CHR(186)
   bBoxText(3) = CHR(200)+LEFT(bBoxText(3),LEN(bBoxText(3))-1)+CHR(188)
ENDCASE

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
*      Display Horizontal or Vertical Buttons in a group box
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
@ BoxRowT,BoxColL SAY bBoxText(1) COLOR &bColor
FOR i = 2 TO bLines
   @ ROW()+1,BoxColL SAY bBoxText(i) COLOR &bColor
ENDFOR

RETURN .T.

*: EOF: BOXPUSH.PRG
